"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _DashboardTitle = _interopRequireDefault(require("./DashboardTitle"));
var _DashboardItem = _interopRequireDefault(require("./DashboardItem"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
/**
 * Copyright 2015 - Present, Yahoo Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */

var DashboardContainer = function DashboardContainer(props) {
  var title = props.title,
    model = props.model,
    DOMNode = props.DOMNode;
  var style = {
    margin: '0px',
    paddingLeft: '0px',
    boxShadow: '0 1px 4px 0 rgba(0,0,0,.28)',
    listStyle: 'none'
  };
  return /*#__PURE__*/_react["default"].createElement("ul", {
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_DashboardTitle["default"], {
    title: title
  }), Object.keys(model).map(function (key) {
    var modelItem = model[key];
    var text = key + " : " + modelItem.value + (modelItem.DOMNode !== DOMNode ? ' (inherited)' : '');
    return /*#__PURE__*/_react["default"].createElement(_DashboardItem["default"], {
      key: text,
      text: text
    });
  }));
};
DashboardContainer.propTypes = {
  title: _propTypes["default"].string.isRequired,
  model: _propTypes["default"].shape().isRequired
};
var _default = DashboardContainer;
exports["default"] = _default;