"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = require("react");
var _variables = require("../utils/variables");
var _DebugDashboard = _interopRequireDefault(require("../libs/DebugDashboard"));
var _useIsomorphicLayoutEffect = _interopRequireDefault(require("./useIsomorphicLayoutEffect"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
/**
 * Copyright 2015 - Present, Yahoo Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */

var useDebugDashboard = function useDebugDashboard(_ref) {
  var node = _ref.node;
  var debugDashboard = (0, _react.useRef)();
  (0, _useIsomorphicLayoutEffect["default"])(function () {
    if (_variables.IS_DEBUG_MODE) {
      debugDashboard.current = new _DebugDashboard["default"](node);
    }
    return function () {
      if (debugDashboard.current) {
        debugDashboard.current.destroy();
      }
    };
  }, [node]);
};
var _default = useDebugDashboard;
exports["default"] = _default;